/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: font.h,v 1.2 2003/08/28 13:48:22 rodzilla Exp $

    The Font class handles text rendering.
    It is based on NeHe's (nehe.gamedev.net) bitmap fonts.
*/

#ifndef __SAM3D_FONT_H__
#define __SAM3D_FONT_H__

#include <SaM3d/file_texture.h>

namespace SaM3d {

	//!	A simple font class.
	class Font {
		//!	The font texture.
		Texture m_texture;
		float m_width, m_height;

		static void init();

	public:
		//!	Constructor.
		Font();

		//!	Destructor.
		~Font();

		//!	Print method.
		void print(const float x, const float y, const float fs, const char* text);

		//!	Formatted print method.
		void printf(const float x, const float y, const float fs, const char*, ...);

		//!	Formatted prit method.
		void printf(const float x, const float y, const char*, ...);

		//!	Set font size.
		void set_size(const float w, const float h);

		//!	Get the width of a rendered text.
		unsigned int get_width(const char* text);

		//!	Get the font height.
		unsigned int get_height();
	};

}

#endif
