/**************************************************************************

    This file is part of SaM3d!, yet another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: opengl.h,v 1.5 2003/08/31 10:04:34 rodzilla Exp $

    Portability stuff concerning OpenGL.
*/

#ifndef __SAM3D_OPENGL_H__
#define __SAM3D_OPENGL_H__

#include <assert.h>
#include <SaM3d/config.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glext.h>

namespace SaM3d {

#ifdef __WINDOWS__
extern PFNGLFOGCOORDFEXTPROC		glFogCoordfEXT;
extern PFNGLACTIVETEXTUREPROC		glActiveTexture;
extern PFNGLCLIENTACTIVETEXTUREPROC	glClientActiveTexture;
#endif

	namespace OpenGL {

		void init();

#ifdef RESTORE_OPENGL_CONTEXT_ON_RESOLUTION_CHANGE
		void clear_context();
#endif

		//!	Set the alpha mask function.
		/*!	\param func the function.
			\param ref the function reference.
		*/
		void alpha_func(GLenum func, float ref = 0.0);

		//!	Enable or disable face culling.
		/*!	\param face Side to be culled (GL_NONE, GL_FRONT or GL_BACK).
		*/
		void cull_face(GLenum face);

	}

}

//#define DEBUG
#ifdef DEBUG
#define CHECK_OPENGL_ERROR assert(glGetError() == GL_NO_ERROR)
#else
#define CHECK_OPENGL_ERROR
#endif

#endif
