/**************************************************************************

    This file is part of "The Science and Magick base library", a
    general library that provides miscellaneous features.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: status.h,v 1.3 2003/08/28 13:48:22 rodzilla Exp $
*/
#ifndef __SAM3D_STATUS_H__
#define __SAM3D_STATUS_H__

#include <SDL/SDL.h>

namespace SaM3d {

	//!	A simple status checker.
	class Status {
		//!	The time when the status was last updated.
		Uint32 m_last_update_time;

		Status(const Status& s);

	public:
		//!	Constructor.
		Status();

		//!	Compares the last update time with the current loop time.
		bool is_up_to_date() const;

		//!	Compares the last update time with another status.
		bool is_up_to_date(const Status& s) const;

		//!	Set the last update time to the current loop time.
		void update();
	};
}

#endif
