/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: config.cpp,v 1.4 2003/08/25 04:56:20 rodzilla Exp $
*/

#ifdef __WINDOWS__
#include <windows.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifdef __WINDOWS__

char* strsep(char **stringp, char *delim) {
	char* i;
	char* j;
	char* tmp = *stringp;

	stringp[0] = NULL;
	for (i = tmp; i[0] != '\0'; i++) {
		for (j = delim; j[0] != '\0'; j++) {
			if (i[0] == j[0]) {
				i[0] = '\0';
				stringp[0] = i+1;
				return tmp;
			}
		}
	}
	return tmp;
}

char* basename (const char *fname) {
	int l = strlen(fname);
	int i;

	for (i = l-1; i >= 0; --i) {
		if (fname[i] == '/' || fname[i] == '\\') {
			return (char*)(fname+i+1);
		}
	}

	return (char*)fname;
}

#endif

namespace SaM3d {

	char* dirname (const char *fname) {
		int l = strlen(fname);
		int i;

		for (i = l-2; i >= 0; --i) {
			if (fname[i] == '/' || fname[i] == '\\') {
				char* buf = (char*)malloc(i+1);
				strncpy(buf, fname, i);
				buf[i] = '\0';
				return buf;
			}
		}

		return strdup(".");
	}

}
