/**************************************************************************

    This file is part of "The Science and Magick base library", a
    general library that provides miscellaneous features.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: debug.cpp,v 1.1 2003/08/24 15:45:00 rodzilla Exp $
*/

#include <iostream>
#include <SaM3d/debug.h>

namespace SaM3d {

	namespace debug {

		using namespace std;

		namespace {

			int indent = 0;

			static char* spaces(int indent) {
				static char* spaces = "                                ";
				static int spaces_l = strlen(spaces);

				return spaces+spaces_l-indent;
			}
		}

		DebugFunction::
		DebugFunction(const char* name) : m_name(name) {
			cout << spaces(indent++) << "--> function " << m_name << endl;
		}

		DebugFunction::
		~DebugFunction() {
			cout << spaces(--indent) << "<-- function " << m_name << endl;
		}

	}

}
