/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: performance_counter.cpp,v 1.2 2003/08/28 13:48:22 rodzilla Exp $
*/

#include <SaM3d/performance_counter.h>

namespace SaM3d {

	CPerformanceCounter::
	CPerformanceCounter() : m_triangles(0) {
	}

	void
	CPerformanceCounter::
	add_frame(const unsigned t) {
		int tmp = t - 1000;

		while (   (m_last_frames.size() > 0)
		       && (m_last_frames.front() < tmp)) {
			m_last_frames.pop_front();
		}
		m_last_frames.push_back(t);
		m_triangles = 0;
	}

	unsigned
	CPerformanceCounter::
	fps() const {
		return m_last_frames.size();
	}
	void
	CPerformanceCounter::
	add_triangles(const unsigned t) {
		m_triangles += t;
	}

	unsigned
	CPerformanceCounter::
	triangles() const {
		return m_triangles;
	}

	CPerformanceCounter&
	CPerformanceCounter::
	instance() {
		static CPerformanceCounter instance;

		return instance;
	}

}

