/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: status.cpp,v 1.1 2003/07/29 14:04:38 rodzilla Exp $
*/

#include <SaM3d/loop.h>
#include <SaM3d/status.h>

namespace SaM3d {

	Status::
	Status() {
		m_last_update_time = 0;
	}

	bool
	Status::
	is_up_to_date() const {
		return (m_last_update_time == Loop::M_current_time);
	}

	bool
	Status::
	is_up_to_date(const Status& s) const {
		return (m_last_update_time >= s.m_last_update_time);
	}

	void
	Status::
	update() {
		m_last_update_time = Loop::M_current_time;
	}

}

