/**************************************************************************

    This file is part of SaM3d!, yet another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: animated_texture.h,v 1.2 2003/08/24 15:45:00 rodzilla Exp $
*/

#ifndef __SAM3D_ANIMATED_TEXTURE_H__
#define __SAM3D_ANIMATED_TEXTURE_H__

#include <vector>
#include <SaM3d/texture.h>

namespace SaM3d {

	class AnimatedTexture : public BaseTexture {
		float		m_period;
		unsigned int	m_nb_textures;
		Texture*	m_textures;

		unsigned char	m_current_texture;

		virtual void release();

	protected:
		virtual void create();

		virtual unsigned is_a() const { return 2000; }
		virtual bool equal(const BaseTexture* t) const;
		virtual unsigned char hash() const;

	public:
		AnimatedTexture(const float frequency,
				const Texture* textures,
				unsigned int nb_textures);
		virtual ~AnimatedTexture();
	};

}

#endif
