/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: bounding_volume.cpp,v 1.3 2003/08/16 06:46:29 rodzilla Exp $

    The Mesh class handle meshes.
*/

#include <SaM3d/opengl.h>
#include <SaM3d/texture.h>
#include "bounding_volume.h"

namespace SaM3d {

	BoundingBox::
	BoundingBox(const Vector3& mins, const Vector3& maxs) : m_mins(mins),
								m_maxs(maxs) {
	}

	bool
	BoundingBox::
	is_visible(const Frustum& f) const {
		return f.test_box(m_mins, m_maxs);
	}

	Vector3
	BoundingBox::
	center() const {
		return 0.5*(m_mins + m_maxs);
	}

}

