/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: bounding_volume.h,v 1.3 2003/08/16 06:46:29 rodzilla Exp $
*/

#ifndef __SAM3D_BOUNDING_VOLUME_H__
#define __SAM3D_BOUNDING_VOLUME_H__

#include <SaM3d/math.h>

namespace SaM3d {

	class BoundingVolume {
	public:
		virtual ~BoundingVolume() { }

		virtual bool is_visible(const Frustum& f) const = 0;
		virtual Vector3 center() const = 0;
	};

	class BoundingBox : public BoundingVolume {
		Vector3	m_mins;
		Vector3	m_maxs;

	public:
		BoundingBox(const Vector3& mins, const Vector3& maxs);
		virtual ~BoundingBox() { }

		virtual bool is_visible(const Frustum& f) const;
		virtual Vector3 center() const;
	};

}

#endif
