/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: bsp_demo.h,v 1.5 2003/08/24 15:45:00 rodzilla Exp $
*/

#ifndef __BSP_DEMO_H__
#define __BSP_DEMO_H__

#include <SaM3d/config_variable.h>
#include <SaM3d/file.h>
#include <SaM3d/loop.h>

class DemoBsp : public SaM3d::Loop {
	static SaM3d::BoolCfgVar M_use_frustum;
	static SaM3d::BoolCfgVar M_use_pvs;

protected:
	virtual bool handle_key_pressed(const SDL_keysym*);
	virtual bool handle_mouse_motion(const int, const int);

public:
	DemoBsp(SaM3d::Dir& dir, const char* bspname);
	virtual ~DemoBsp();

	virtual void draw();
	virtual void move(float);

	void toggle_lightmaps();
};

#endif
