/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: color.cpp,v 1.1.1.1 2003/07/25 19:28:17 rodzilla Exp $

    The SM::Material class handles materials
*/

#include "color.h"

using namespace std;

Color::
Color() : r(0), g(0), b(0), a(1) {
}

Color::
~Color() {
}

Color operator *(float x, const Color& c) {
	Color rv;

	rv.r = (GLubyte)(x*c.r);
	rv.g = (GLubyte)(x*c.g);
	rv.b = (GLubyte)(x*c.b);
	rv.a = (GLubyte)(x*c.a);

	return rv;
}

void
Color::
glColor() {
	glColor4ub(r, g, b, a);
}

void
Color::
glMaterial(GLenum face, GLenum pname) {
	GLfloat tmp[4];

	tmp[0] = ((GLfloat)r)/255.0;
	tmp[1] = ((GLfloat)g)/255.0;
	tmp[2] = ((GLfloat)b)/255.0;
	tmp[3] = ((GLfloat)a)/255.0;
	glMaterialfv(face, pname, tmp);
}


std::ostream& operator <<(std::ostream& s, const Color& c) {
	return s << "(" << c.r << ", " << c.g << ", " << c.b << ", " << c.a << ")";
}

