/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: color.h,v 1.1.1.1 2003/07/25 19:28:17 rodzilla Exp $
*/

#ifndef __SAM3D_COLOR_H__
#define __SAM3D_COLOR_H__

#include <iostream>
#include <SaM3d/opengl.h>

class Color {
public:
	GLubyte r;
	GLubyte g;
	GLubyte b;
	GLubyte a;

	Color();
	~Color();

	bool operator ==(const Color& c) const {
		return (r == c.r) &&
		       (g == c.g) &&
		       (b == c.b) &&
		       (a == c.a);
	}

	Color& operator =(const Color& c) {
		r = c.r;
		g = c.g;
		b = c.b;
		a = c.a;

		return *this;
	}

	Color& operator +=(const Color& c) {
		r += c.r;
		g += c.g;
		b += c.b;
		a += c.a;

		return *this;
	}

	void glColor();
	void glMaterial(GLenum face, GLenum pname);
};

Color operator *(float x, const Color& c);

std::ostream& operator <<(std::ostream& s, const Color& c);

#endif
