/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: loader_bsp.h,v 1.3 2003/08/26 13:55:51 rodzilla Exp $
*/

#ifndef __SAM3D_LOADER_BSP_H__
#define __SAM3D_LOADER_BSP_H__

#include <map>
#include <SaM3d/file.h>
#include "map.h"
#include "vertex.h"

namespace SaM3d {

	class Loader_BSP {
		Dir m_dir;
		File m_file;
		Map* m_map;

		Loader_BSP(const Dir& dir, const char* bspname);
		void read_bsp_file();

		Texture m_levelshot;

		void draw(const std::string& msg, unsigned int percent);

		VertexTLmNC* patch_to_grid(VertexTLmNC* patch,
					   unsigned int hsize, unsigned int hsub,
					   unsigned int vsize, unsigned int vsub);

	public:
		static Map* read(const Dir& dir, const char* filename);
		static Map* read(const char* filename);
	};

}

#endif
