/**************************************************************************

    This file is part of "The Science and Magick base library", a
    general library that provides miscellaneous features.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: lua.h,v 1.2 2003/07/30 07:20:46 rodzilla Exp $
*/

#ifndef __SAM3D_LUA_H__
#define __SAM3D_LUA_H__
#ifndef NO_LUA

extern "C" {
#include <lua.h>
#include <lauxlib.h>
#include <lualib.h>
}
#include <string>
#include <SaM3d/console.h>

namespace SaM3d {

	class CLua : public CConsole::Interpreter {
		lua_State* m_lua_state;
		std::string m_lua_command;

		CLua();

	public:
		virtual ~CLua();

		static CLua& instance();

		void register_cfunction(const char*, lua_CFunction);
		void openlib(const char* libname, const luaL_reg* l);
		void do_file(const char* filename);
		virtual void do_string(const std::string&);
	};

}

#define Lua SaM3d::CLua::instance()

#endif // NO_LUA
#endif
