/**************************************************************************

    This file is part of SaM3d!, yet another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: main.cpp,v 1.10 2003/08/25 04:56:20 rodzilla Exp $
*/

#include <SaM3d/config_variable.h>
#include <SaM3d/display.h>
#include <SaM3d/file.h>
#include "bsp_demo.h"
#include "q3shaders.h"
#ifndef NO_LUA
#include "lua.h"
#endif

using namespace SaM3d;

int main(int argc, char ** argv) {
	StringCfgVar pak_path("pak_path", "");
	StringCfgVar map_name("map_name", "");

	//	Initialize the display.
	Display;

#ifndef NO_LUA
	//	Initialize the Lua interpreter
	Lua.do_file("q3view.lua");
	//	Read the config file
	Lua.do_file("config.lua");
#endif

	if (argc > 1) {
		pak_path = argv[1];
	}
	if (argc > 2) {
		map_name = argv[2];
	}

	{	// Load Q3 shaders.
		Dir pak_dir(pak_path);

		Q3ShaderManager.load_shaders(pak_dir);

		DemoBsp d(pak_dir, map_name);
		d.start();
	}

	return 0;
}

