/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: map.h,v 1.6 2003/08/31 10:04:34 rodzilla Exp $
*/

#ifndef __SAM3D_MAP_H__
#define __SAM3D_MAP_H__

#include <stdio.h>
#include <SaM3d/file_texture.h>
#include "bsp.h"
#include "o3d.h"
#include <vector>

namespace SaM3d {

	class Map {
		std::vector<O3d*>	m_mesh_l;
		BSP::Node*		m_bsp_tree;

	public:
		Map();
		~Map();

		void draw();
		void draw(const Frustum& f);
		void draw(const Vector3& p);
		void draw(const Vector3& p, const Frustum& f);

	friend class Loader_BSP;
	};

}

#endif
