/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: o3d.cpp,v 1.1 2003/08/31 10:04:34 rodzilla Exp $

    The O3d class handle meshes.
*/

#include <assert.h>
#include <unistd.h>
#include <iostream>
#include <SaM3d/opengl.h>
#include <SaM3d/performance_counter.h>
#include "mesh.h"

namespace SaM3d {

	using namespace std;

	O3d::
	O3d() {
		m_bounding_volume = NULL;
	}

	O3d::
	~O3d() {
	}

	bool
	O3d::
	is_up_to_date() {
		return m_status.is_up_to_date();
	}

	void
	O3d::
	update() {
		m_status.update();
	}

	void
	O3d::
	draw(const Frustum& f) {
		if (m_bounding_volume) {
			if (!m_bounding_volume->is_visible(f)) return;
		}
		draw();
	}

}

