/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: o3d.h,v 1.1 2003/08/31 10:04:34 rodzilla Exp $
*/

#ifndef __SAM3D_O3D_H__
#define __SAM3D_O3D_H__

#include <SaM3d/math.h>
#include <SaM3d/status.h>
#include "bounding_volume.h"

namespace SaM3d {

	class O3d {
	protected:
		BoundingVolume*	m_bounding_volume;

		Status		m_status;

	public:
		O3d();
		virtual ~O3d();

		virtual void calculate_bounding_volume() = 0;

		bool is_up_to_date();
		void update();

		virtual bool is_transparent() { return false; }

		void draw(const Frustum& f);
		virtual void draw() = 0;
	};

}

#endif
