/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: q3lexer.h,v 1.1 2003/08/24 15:45:00 rodzilla Exp $
*/

#ifndef __SAM3D_Q3LEXER_H__
#define __SAM3D_Q3LEXER_H__

#include <SaM3d/file.h>
#include <SaM3d/log.h>
#include "q3shaders.h"

class CQ3ShaderManager::Lexer {
	SaM3d::File m_file;
	char m_next_char1;
	char m_next_char2;
	unsigned char m_next_chars;

	void fill_char_buffer();
	char get();
	char look();

public:
	Lexer(const SaM3d::Dir& d, const std::string& filename);

	void skip_spaces();
	void skip_spaces_and_endl();
	bool get_path(std::string& s);
	bool get_identifier(std::string& s);
	bool get_float(float& f);
	bool get_special(char c);
	bool eof();
};

#endif

