/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: q3shaders.h,v 1.6 2003/08/31 10:04:34 rodzilla Exp $
*/

#ifndef __SAM3D_Q3SHADERS_H__
#define __SAM3D_Q3SHADERS_H__

#include <map>
#include <string>
#include <SaM3d/file.h>
#include "shader.h"
#include "sky.h"

struct Q3Shader {
	SaM3d::BaseShader*	shader;
	SaM3d::Sky* 		sky;
};

class CQ3ShaderManager {
	class Lexer;
	class Parser;

friend class CQ3ShaderManager::Parser;

	CQ3ShaderManager();

	std::map<std::string, Q3Shader*> m_shaders;

	void draw(const std::string& file_name, unsigned int percent);

public:
	static CQ3ShaderManager& instance();

	void load_shaders(SaM3d::Dir& q3dir);

	Q3Shader* get_shader(const std::string& name);
};

#define Q3ShaderManager (CQ3ShaderManager::instance())

#endif

