/**************************************************************************

    This file is part of "The Science and Magick 3d Engine", yet
    another OpenGL-based engine.
    Copyright (C) 2001 - 2002 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: sky.h,v 1.1 2003/08/31 10:04:34 rodzilla Exp $
*/

#ifndef __SAM3D_SKY_H__
#define __SAM3D_SKY_H__

#include <string>
#include <SaM3d/opengl.h>
#include <SaM3d/file_texture.h>
#include "o3d.h"
#include "shader.h"

namespace SaM3d {

	class SkyBox {
		Texture m_tex_ft;
		Texture m_tex_bk;
		Texture m_tex_lf;
		Texture m_tex_rt;
		Texture m_tex_up;
		Texture m_tex_dn;

	public:
		SkyBox(Dir& dir, const std::string& prefix);

		void draw();
	};

	class SkyDome {
		float m_cloud_height;
		Shader m_shader;

	public:
		SkyDome(const Shader& shader, float cloud_height = 128);

		void draw();
	};

	class Sky : public O3d {
		SkyBox*		m_far;
		SkyDome*	m_clouds;
		SkyBox*		m_near;
		
	public:
		Sky(SkyBox* near, SkyDome* clouds, SkyBox* far);

		virtual void calculate_bounding_volume() { }
		virtual void draw();
	};
}

#endif
