/**************************************************************************

    This file is part of SaM3d!, yet another OpenGL-based engine.
    Copyright (C) 2001 - 2003 Rodolphe Suescun

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************
    $Id: lesson_02.cpp,v 1.1.1.1 2003/07/25 19:28:30 rodzilla Exp $
*/

#include <SaM3d/display.h>
#include <SaM3d/opengl.h>
#include <SaM3d/performance_counter.h>
#include "lesson_02.h"

using namespace SaM3d;

Lesson02::
Lesson02() {
	m_camera.set_fov(0.1, 200);
}

// Init OpenGL parameters for this scene.
void
Lesson02::
init() {
	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);
	glDepthFunc(GL_LESS);
	glDisable(GL_CULL_FACE);
}

// Init OpenGL parameters for this scene.
void
Lesson02::
draw() {
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	// Clear the display.

	m_camera.activate();

	glTranslatef(-1.5f,0.0f,-6.0f);		// Move Left 1.5 Units And Into The Screen 6.0

	glBegin(GL_TRIANGLES);			// Drawing Using Triangles
	glVertex3f( 0.0f, 1.0f, 0.0f);		// Top
	glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left
	glVertex3f( 1.0f,-1.0f, 0.0f);		// Bottom Right
	glEnd();				// Finished Drawing The Triangle			
	glTranslatef(3.0f,0.0f,0.0f);		// Move Right 3 Units

	glBegin(GL_QUADS);			// Draw A Quad
	glVertex3f(-1.0f, 1.0f, 0.0f);		// Top Left
	glVertex3f( 1.0f, 1.0f, 0.0f);		// Top Right
	glVertex3f( 1.0f,-1.0f, 0.0f);		// Bottom Right
	glVertex3f(-1.0f,-1.0f, 0.0f);		// Bottom Left
	glEnd();				// Done Drawing The Quad

	{					// Set the window title.
		char buf[64];

		sprintf(buf, "Your first polygon. Frame rate: %i.", PerformanceCounter.fps());
		Display.set_window_title(buf);
	}
}

// Update the forward_move, up_move and right_move variables when a key is pressed.
bool
Lesson02::
handle_key_pressed(const SDL_keysym *keysym) {
	switch (keysym->sym) {
		default:
			return Loop::handle_key_pressed(keysym);
	}
	return true;
}

